from slashdb.dbproxies.sqlalchemy_sdb.model import SQLAlchemyModel
from slashdb.dbproxies.sqlalchemy_sdb.model import SQLAlchemyModuleMaker

from .dataproxy import SnowflakeDataProxy, SnowflakeSQLTypeConverter
from .dbconfig import SnowflakeDBConfig
from .patches import patch_snowflake

__version__ = '1.2.1'

DB_TYPES = ['snowflake']

patch_snowflake()


class SnowflakeModel(SQLAlchemyModel):
    db_types = DB_TYPES
    sql_type_converter = SnowflakeSQLTypeConverter()


class SnowflakeModuleMaker(SQLAlchemyModuleMaker):
    db_types = DB_TYPES
    model_class = SnowflakeModel


ModuleMaker = SnowflakeModuleMaker
Model = SnowflakeModel
DataProxy = SnowflakeDataProxy
DBConfig = SnowflakeDBConfig
DB_TYPES = DB_TYPES
